"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class DemographicElegibilityCriteria(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "sex",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import reports as reports_6_1_0

        return {
            "ageRange": reports_6_1_0.AgeRange,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import participant as participant_1_2_0

        return {
            "sex": participant_1_2_0.Sex,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_6 import participant as participant_1_2_0
        from protocols.protocol_7_6 import reports as reports_6_1_0

        return {
            "org.gel.models.report.avro.AgeRange": reports_6_1_0.AgeRange,
            "org.gel.models.participant.avro.Sex": participant_1_2_0.Sex,
            "org.gel.models.report.avro.DemographicElegibilityCriteria": reports_6_1_0.DemographicElegibilityCriteria,
        }

    __slots__ = [
        "sex",
        "ageRange",
    ]

    def __init__(
        self,
        sex,
        ageRange=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_1_0.DemographicElegibilityCriteria model.

        :param sex:
        :type sex: Sex
        :param ageRange:
        :type ageRange: None | AgeRange
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.1.0"
